Subject: Re: skb->priority on arp packets

From: Ben Greear <[email-masked]>
Date: Mon, 04 Jun 2007 15:02:31 -0700

Waskiewicz Jr, Peter P wrote:
>> is it possible to set the skb->priority on arp packets 
>> generated by the kernel?
>> I want to to set the 802.1p priority on arp and ip packets on 
>> an interface. On ip packets, this can be done by the iptables 
>> CLASSIFY target and the 
>> skb->priority mapping from the vlan implementation.
>>
>> any ideas?
> 
> Currently unclassified ip packets have skb->priority set in ipsockglue,
> by translating the IP TOS field into a Linux priority.  This is not the
> same priority as 802.1p, rather, it's a Linux-based OS priority
> classification for dequeuing priority in schedulers such as sch_prio.
> 802.1p lives in the VLAN tag, which is separate from skb->priority.  I'd
> suggest reading http://lartc.org/howto/lartc.qdisc.classless.html to see
> what exactly skb->priority is used for in sch_prio and pfifo_fast, and
> how the ip layer determines a packet's priority.  The skb->priority
> field is also used in other ways in other qdiscs I'm not completely
> familiar with, but it's not directly related to priority of the packet.
> I'd need to look closer at those qdiscs to be specific.
> 
> That being said, the only way I can think of manipulating skb->priority
> on arp packets (and actually setting it) is modifying a qdisc to set
> skb->priority if it matches a filter created using the tc command.

If you do manage to get the skb->priority set, then you can use vconfig
to set up mapping between skb->priority and the VLAN priority field.

Thanks,
Ben

> 
> Cheers,
> -PJ Waskiewicz
> -
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com